local E, L, V, P, G = unpack(ElvUI); --Import: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
local MaUI = E:NewModule('MaUI', 'AceHook-3.0', 'AceEvent-3.0', 'AceTimer-3.0'); --Create a plugin within ElvUI and adopt AceHook-3.0, AceEvent-3.0 and AceTimer-3.0. We can make use of these later.
local EP = LibStub("LibElvUIPlugin-1.0") --We can use this to automatically insert our GUI tables when ElvUI_Config is loaded.
local addonName, addonTable = ... --See http://www.wowinterface.com/forums/showthread.php?t=51502&p=304704&postcount=2

--Default options
P["MaUI"] = {
	['installed'] = nil,
	["SomeToggleOption"] = true,
	["SomeRangeOption"] = 5,
}

--Function we can call when a setting changes.
--In this case it just checks if "SomeToggleOption" is enabled. If it is it prints the value of "SomeRangeOption", otherwise it tells you that "SomeToggleOption" is disabled.
function MaUI:Update()
	local enabled = E.db.MaUI.SomeToggleOption
	local range = E.db.MaUI.SomeRangeOption

	if enabled then
		print(range)
	else
		print("SomeToggleOption is disabled")
	end
end

--This function inserts our GUI table into the ElvUI Config. You can read about AceConfig here: http://www.wowace.com/addons/ace3/pages/ace-config-3-0-options-tables/
function MaUI:InsertOptions()
	E.Options.args.MaUI = {
		order = 100,
		type = "group",
		name = "|cFF6FFF10MaUI|r",
		args = {
			info = {
				order = 1,
				type = "group",
				name = "",
				guiInline = true,
				args = {
					logo = {
						order = 1,
						type = "description",
						name = "",
						fontSize = "medium",
						image = function() return "Interface\\AddOns\\ElvUI_MaUI\\media\\textures\\logo_MaUI.tga", 256, 128 end,
						imageCoords = { 0, 0.99, 0.01, 0.99 },
					},
					-- descript = {
						-- order = 2,
						-- type = "description",
						-- name = L["MaUI is an external ElvUI mod"],
						-- fontSize = "medium",
					-- },
				},
			},
			mconf = {
				order = 2,
				type = "group",
				name = "",
				guiInline = true,
				args = {
					button = {
						order = 1,
						name = "Install",
						type = 'execute',
						func = function() E:GetModule("PluginInstaller"):Queue(MaUI.installTable); E:ToggleConfig()end,
					},
				},
			},
			credit = {
				order = 3,
				type = "description",
				name = L["Thanks to the www.tukui.org community, Blazeflack and Merathilis for their great help."],
				fontSize = "medium",

			},
		},
	}
end

function MaUI:Initialize()
	if IsAddOnLoaded('ElvUI_mMediaTag') then
		DisableAddOn("ElvUI_mMediaTag")
		ReloadUI()
		
		print ("|cffFF1744##########################################|r")
		print ("|cffFF1744Attention|r |cff1784d1ElvUI_mMediaTag|r was deactivated, because all functions are available in this AddOn.")
		print ("|cffFF1744##########################################|r")
	end

	if E.private.install_complete == E.version and E.db.MaUI.installed == nil then 
		E:GetModule("PluginInstaller"):Queue(MaUI.installTable)
	end
	
	print ("Thanks for using |cff76FF03MaUI|r for |cff1784d1ElvUI|r.")
	
	--Register plugin so options are properly inserted when config is loaded
	EP:RegisterPlugin(addonName, MaUI.InsertOptions)
end

E:RegisterModule(MaUI:GetName()) --Register the module with ElvUI. ElvUI will now call MaUI:Initialize() when ElvUI is ready to load our plugin.